POJ 3126 Prime Path

来源:互联网 发布:mac看nba直播 编辑:程序博客网 时间:2024/05/16 17:30

Description:

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
31033 81791373 80171033 1033
Sample Output
670

题目大意:

给定两个素数, 变换数字的要求是每次只能变其中一位的数并且每变化一次的数必须为素数。 求从第一个数到第二个数的最小步数。

解题思路:

因为是求最小步数所以适合用BFS,队列中枚举每一位的每一种可能取值, 输出步数最小的即可。

代码:

#include <iostream>
#include <sstream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <utility>
#include <string>
#include <cmath>
#include <vector>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <set>

using namespace std;

/*
 *ios::sync_with_stdio(false);
 */

typedef long long ll;
typedef unsigned long long ull;
const int dir[5][2] = {0, 1, 0, -1, 1, 0, -1, 0, 0, 0};
const ll ll_inf = 0x7fffffff;
const int inf = 0x3f3f3f;
const int mod = 1000000;
const int Max = 10000;

struct node {
    int num;
    int step;
};
int st, ed, tot;
bool flag[Max], vis[Max];
int prime[Max];

bool isPrime(int x) {
    if (x == 2 || x == 3)
        return true;
    else if (x <= 1 || x % 2 == 0)
        return false;
    else if (x > 3) {
        for (int i = 3; i * i <= x; i += 2) {
            if (x % i == 0) {
                return false;
            }
        }
        return true;
    }
}

void BFS() {
    node temp, t;
    t.num = st, t.step = 0; vis[st] = 1;
    queue < node> Q;
    Q.push(t);
    while (!Q.empty()) {
        temp = Q.front();
        if (temp.num == ed) {
            printf("%d\n", temp.step);
            return ;
        }
        Q.pop();

        int ge = temp.num % 10;
        int shi = (temp.num / 10) % 10;
        // enumeration ge
        for (int i = 1; i <= 9; i += 2) {
            int gewei = (temp.num / 10) * 10 + i;
            if (gewei != temp.num && !vis[gewei] && isPrime(gewei)) {
                vis[gewei] = 1;
                t.num = gewei;
                t.step = temp.step + 1;
                Q.push(t);
            }
        }
        // enumeration shi
        for (int i = 0; i <= 9; ++i) {
            int shiwei = (temp.num / 100) * 100 + i * 10 + ge;
            if (shiwei != temp.num && !vis[shiwei] && isPrime(shiwei)) {
                vis[shiwei] = 1;
                t.num = shiwei;
                t.step = temp.step + 1;
                Q.push(t);
            }
        }
        // enumeration bai
        for (int i = 0; i <= 9; ++i) {
            int baiwei = (temp.num / 1000) * 1000 + (i * 100 + shi * 10) + ge;
            if (baiwei != temp.num && !vis[baiwei] && isPrime(baiwei)) {
                vis[baiwei] = 1;
                t.num = baiwei;
                t.step = temp.step + 1;
                Q.push(t);
            }
        }
        // enumeration qian
        for (int i = 1; i <= 9; ++i) {
            int qianwei = temp.num % 1000 + i * 1000;
            if (qianwei != temp.num && !vis[qianwei] && isPrime(qianwei)) {
                vis[qianwei] = 1;
                t.num = qianwei;
                t.step = temp.step + 1;
                Q.push(t);
            }
        }
    }
    printf("Impossible\n");
    return ;
}

int main() {
    freopen("input.txt", "r", stdin);
    int t;
    // initialization
    scanf("%d", &t);
    while (t--) {
        memset(vis, 0, sizeof(vis));
        scanf("%d %d", &st, &ed);
        BFS();
    }
    return 0;
}


原创粉丝点击